const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Payroll_runsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const payroll_runs = await db.payroll_runs.create(
      {
        id: data.id || undefined,

        country: data.country || null,
        pay_period_start: data.pay_period_start || null,
        pay_period_end: data.pay_period_end || null,
        pay_date: data.pay_date || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await payroll_runs.setOrganizations(data.organizations || null, {
      transaction,
    });

    return payroll_runs;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const payroll_runsData = data.map((item, index) => ({
      id: item.id || undefined,

      country: item.country || null,
      pay_period_start: item.pay_period_start || null,
      pay_period_end: item.pay_period_end || null,
      pay_date: item.pay_date || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const payroll_runs = await db.payroll_runs.bulkCreate(payroll_runsData, {
      transaction,
    });

    // For each item created, replace relation files

    return payroll_runs;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const payroll_runs = await db.payroll_runs.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.country !== undefined) updatePayload.country = data.country;

    if (data.pay_period_start !== undefined)
      updatePayload.pay_period_start = data.pay_period_start;

    if (data.pay_period_end !== undefined)
      updatePayload.pay_period_end = data.pay_period_end;

    if (data.pay_date !== undefined) updatePayload.pay_date = data.pay_date;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await payroll_runs.update(updatePayload, { transaction });

    if (data.organizations !== undefined) {
      await payroll_runs.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return payroll_runs;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const payroll_runs = await db.payroll_runs.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of payroll_runs) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of payroll_runs) {
        await record.destroy({ transaction });
      }
    });

    return payroll_runs;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const payroll_runs = await db.payroll_runs.findByPk(id, options);

    await payroll_runs.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await payroll_runs.destroy({
      transaction,
    });

    return payroll_runs;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const payroll_runs = await db.payroll_runs.findOne(
      { where },
      { transaction },
    );

    if (!payroll_runs) {
      return payroll_runs;
    }

    const output = payroll_runs.get({ plain: true });

    output.deductions_payroll_run =
      await payroll_runs.getDeductions_payroll_run({
        transaction,
      });

    output.earnings_payroll_run = await payroll_runs.getEarnings_payroll_run({
      transaction,
    });

    output.taxes_payroll_run = await payroll_runs.getTaxes_payroll_run({
      transaction,
    });

    output.organizations = await payroll_runs.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.country) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('payroll_runs', 'country', filter.country),
        };
      }

      if (filter.calendarStart && filter.calendarEnd) {
        where = {
          ...where,
          [Op.or]: [
            {
              pay_period_start: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
            {
              pay_period_end: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
          ],
        };
      }

      if (filter.pay_period_startRange) {
        const [start, end] = filter.pay_period_startRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            pay_period_start: {
              ...where.pay_period_start,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            pay_period_start: {
              ...where.pay_period_start,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.pay_period_endRange) {
        const [start, end] = filter.pay_period_endRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            pay_period_end: {
              ...where.pay_period_end,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            pay_period_end: {
              ...where.pay_period_end,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.pay_dateRange) {
        const [start, end] = filter.pay_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            pay_date: {
              ...where.pay_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            pay_date: {
              ...where.pay_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.payroll_runs.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('payroll_runs', 'country', query),
        ],
      };
    }

    const records = await db.payroll_runs.findAll({
      attributes: ['id', 'country'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['country', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.country,
    }));
  }
};
